local GetBuildInfo, InterfaceOptionsFrame_OpenToCategory, LibStub, SlashCmdList, idTweaks, idTweaksOptions, idTweaksUtils, Option, AceAddon, AceDB, AceDBOptions, AceConfig, AceConfigDialog, LibSharedMedia, Addon
do
  local _obj_0 = _G
  GetBuildInfo, InterfaceOptionsFrame_OpenToCategory, LibStub, SlashCmdList, idTweaks, idTweaksOptions, idTweaksUtils = _obj_0.GetBuildInfo, _obj_0.InterfaceOptionsFrame_OpenToCategory, _obj_0.LibStub, _obj_0.SlashCmdList, _obj_0.idTweaks, _obj_0.idTweaksOptions, _obj_0.idTweaksUtils
end
Option = idTweaksOptions.Option
AceAddon = LibStub("AceAddon-3.0")
AceDB = LibStub("AceDB-3.0")
AceDBOptions = LibStub("AceDBOptions-3.0")
AceConfig = LibStub("AceConfig-3.0")
AceConfigDialog = LibStub("AceConfigDialog-3.0")
LibSharedMedia = LibStub("LibSharedMedia-3.0")
do
  local _class_0
  local _base_0 = {
    anchor = {
      TL = "TOPLEFT",
      TC = "TOP",
      TR = "TOPRIGHT",
      ML = "LEFT",
      MC = "CENTER",
      MR = "RIGHT",
      BL = "BOTTOMLEFT",
      BC = "BOTTOM",
      BR = "BOTTOMRIGHT"
    },
    is_bc = function(self)
      return not self:is_retail()
    end,
    is_retail = function(self)
      return (select(4, GetBuildInfo())) > 30000
    end,
    add_module = function(self, module)
      self.modules[module.name] = module
    end,
    remove_module = function(self, module)
      return table.remove(self.modules, module.name)
    end,
    is_module_enabled = function(self, module_name)
      return not not self.modules[module_name] and self.modules[module_name].is_enabled()
    end,
    set_database = function(self)
      self.db = AceDB:New(tostring(self.name) .. "DB", nil, "Default")
    end,
    set_options = function(self)
      self.options = Option(self, self.name, self.name, self.name, { }, { })
      self.profile_options = AceDBOptions:GetOptionsTable(self.db)
    end,
    register_options = function(self)
      if self:is_retail() then
        AceConfig:RegisterOptionsTable(self.name, self.options:get_aceconfig_options())
        AceConfig:RegisterOptionsTable(tostring(self.name) .. "-Profiles", self.profile_options)
        AceConfigDialog:AddToBlizOptions(self.name)
        AceConfigDialog:AddToBlizOptions(tostring(self.name) .. "-Profiles", "Profiles", self.name)
      end
      if self:is_bc() then
        local options = self.options:get_aceconfig_options()
        options.args.profile = self.profile_options
        return AceConfig:RegisterOptionsTable(self.name, options, "idtweaks")
      end
    end,
    register_defaults = function(self)
      self.defaults = {
        profile = self.options:get_aceconfig_defaults()
      }
      return self.db:RegisterDefaults(self.defaults)
    end,
    register_slash_commands = function(self) end,
    register_media = function(self)
      LibSharedMedia:Register(LibSharedMedia.MediaType.FONT, "Myriad Condensed Web", "Interface\\AddOns\\idTweaks\\media\\fonts\\Myriad Condensed Web.ttf")
      LibSharedMedia:Register(LibSharedMedia.MediaType.BORDER, "Square Clean", "Interface\\AddOns\\idTweaks\\media\\textures\\ABFBorder")
      LibSharedMedia:Register(LibSharedMedia.MediaType.BACKGROUND, "Chat Frame", "Interface\\ChatFrame\\ChatFrameBackground")
      LibSharedMedia:Register(LibSharedMedia.MediaType.STATUSBAR, "BantoBar", "Interface\\AddOns\\idTweaks\\media\\textures\\banto")
      LibSharedMedia:Register(LibSharedMedia.MediaType.STATUSBAR, "Smooth", "Interface\\AddOns\\idTweaks\\media\\textures\\smooth")
      LibSharedMedia:Register(LibSharedMedia.MediaType.STATUSBAR, "Perl", "Interface\\AddOns\\idTweaks\\media\\textures\\perl")
      LibSharedMedia:Register(LibSharedMedia.MediaType.STATUSBAR, "Glaze", "Interface\\AddOns\\idTweaks\\media\\textures\\glaze")
      LibSharedMedia:Register(LibSharedMedia.MediaType.STATUSBAR, "Charcoal", "Interface\\AddOns\\idTweaks\\media\\textures\\Charcoal")
      LibSharedMedia:Register(LibSharedMedia.MediaType.STATUSBAR, "Otravi", "Interface\\AddOns\\idTweaks\\media\\textures\\otravi")
      LibSharedMedia:Register(LibSharedMedia.MediaType.STATUSBAR, "Striped", "Interface\\AddOns\\idTweaks\\media\\textures\\striped")
      LibSharedMedia:Register(LibSharedMedia.MediaType.STATUSBAR, "LiteStep", "Interface\\AddOns\\idTweaks\\media\\textures\\LiteStep")
      LibSharedMedia:Register(LibSharedMedia.MediaType.STATUSBAR, "Aluminium", "Interface\\AddOns\\idTweaks\\media\\textures\\Aluminium")
      return LibSharedMedia:Register(LibSharedMedia.MediaType.STATUSBAR, "Minimalist", "Interface\\AddOns\\idTweaks\\media\\textures\\Minimalist")
    end,
    positioning = function(self)
      for k, v in pairs(idTweaks.modules) do
        v:positioning()
      end
    end
  }
  _base_0.__index = _base_0
  _class_0 = setmetatable({
    __init = function(self)
      self.name = "idTweaks"
      self.ace_addon = AceAddon:NewAddon(self.name, "AceConsole-3.0")
      self.db = nil
      self.modules = { }
      self.ace_addon.OnInitialize = function()
        self:set_database()
        self:set_options()
        self:register_slash_commands()
        return self:register_media()
      end
      self.ace_addon.OnEnable = function()
        self:register_options()
        return self:register_defaults()
      end
      self.ace_addon.OnDisable = function() end
    end,
    __base = _base_0,
    __name = "Addon"
  }, {
    __index = _base_0,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  Addon = _class_0
end
_G.idTweaksAddon = Addon
